Index: /trunk/contactcenter/inc/class.bo_global_ldap_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_global_ldap_catalog.inc.php	(revision 167)
+++ /trunk/contactcenter/inc/class.bo_global_ldap_catalog.inc.php	(revision 284)
@@ -16,13 +16,16 @@
 	*/
 	include_once('class.abo_catalog.inc.php');
-	
+
 	class bo_global_ldap_catalog extends abo_catalog
 	{
 		var $ldap;
-	
+
 		var $src_info;
-		
+
 		var $trans_table;
-		
+
+		// used to determine if a catalog is external
+		var $external;
+
 		var $fields = array(
 			'id_contact'    => true,
@@ -40,5 +43,8 @@
 			'pgp_key'       => true,
 			'notes'         => true,
-			
+			'department'    => true,
+
+			'empNumber'     => true,
+
 			/* Array fields */
 			'companies'     => true,
@@ -47,24 +53,37 @@
 			'connections'   => true
 		);
-		
+
 		/*
-		
+
 			@function global_ldap_catalog
 			@abstract Constructor
 			@author Raphael Derosso Pereira
-			
+			@author Mário César Kolling (external catalogs)
+
 			@param integer $id_source The ID of the LDAP source
-			
+			@param string $context Ldap bind DN
+			@param integer $external 0 = internal catalog, 1 = external catalog
+
 		*/
-		function bo_global_ldap_catalog ( $id_source, $context )
-		{
+		function bo_global_ldap_catalog ( $id_source, $context, $external = 0 )
+		{
+
+			$this->external = $external;
+
 			if (!function_exists('ldap_search'))
 			{
 				exit('PHP LDAP support Unavailable!');
 			}
-			
+
 			$this->ldap = CreateObject('contactcenter.bo_ldap_manager');
-			
-			$all_src = $this->ldap->get_all_ldap_sources();
+
+			if ($this->external)
+			{
+				$all_src = $this->ldap->get_external_ldap_sources();
+			}
+			else
+			{
+				$all_src = $this->ldap->get_all_ldap_sources();
+			}
 
 			if (!$all_src[$id_source] or !$context)
@@ -75,9 +94,17 @@
 			$this->src_info = $all_src[$id_source];
 			$this->src_info['context'] = $context;
-			$this->trans_table = $this->ldap->get_ldap_fields_association($id_source);
-		}
-		
+
+			if ($this->external)
+			{
+				$this->trans_table = $this->ldap->get_external_ldap_fields_association($id_source);
+			}
+			else
+			{
+				$this->trans_table = $this->ldap->get_ldap_fields_association($id_source);
+			}
+		}
+
 		/*
-		
+
 			@function find
 			@abstract Searches the LDAP directory for the specified fields with
@@ -85,5 +112,5 @@
 				that matches the rules.
 			@author Raphael Derosso Pereira
-			
+
 			@param array $what The fields to be taken
 			@param array $rules The rules to be match. See class.abo_catalog.inc.php
@@ -94,12 +121,12 @@
 					'offset' => (integer) [NOT IMPLEMENTED]
 				)
-		
+
 		*/
 		function find($what, $rules=false, $other=false)
 		{
 			$restric_fields = $this->get_restrictions_without_branch($rules);
-			
+
 			$trans_f = $this->translate_fields($what, $restric_fields);
-			
+
 			foreach($trans_f as $orig => $field_a)
 			{
@@ -109,26 +136,30 @@
 				}
 			}
-			
+
 			$fields = array_unique($fields);
-			
+
 			$filter = $this->process_restrictions($rules, $trans_f);
 
 			if(strstr($this->src_info['context'], "ldap://")) {
 				$refer_context 	= str_replace("??base","",preg_replace('!^(ldap://[^/]+)/(.*$)!', '\\2', $this->src_info['context']));
-				$host	= preg_replace('!^(ldap://[^/]+)/.*$!', '\\1', $this->src_info['context']);				
+				$host	= preg_replace('!^(ldap://[^/]+)/.*$!', '\\1', $this->src_info['context']);
 				$this->src_info['host'] = $host;
-				//$this->src_info['acc'] = '';
-				//$this->src_info['pw']  = '';				
-			}			
+				$this->src_info['acc'] = '';
+				$this->src_info['pw']  = '';
+			}
 
 			$ldap = $GLOBALS['phpgw']->common->ldapConnect($this->src_info['host'], $this->src_info['acc'], $this->src_info['pw'], true);
-			
+
 			if (!$ldap)
 			{
 				return false;
 			}
-			
-			$fields[]  ='phpgwAccountVisible';
-			$result_r = @ldap_search($ldap ,($refer_context  ? $refer_context  : $this->src_info['context']), $filter, $fields);
+
+			if (!$this->external)
+			{
+				$fields[]  ='phpgwAccountVisible';
+			}
+
+			$result_r = @ldap_search($ldap ,($refer_context  ? $refer_context  : $this->src_info['context']), $filter, $fields, 0);
 
 			if (!$result_r)
@@ -136,5 +167,5 @@
 				return false;
 			}
-			
+
 			if ($other['order'])
 			{
@@ -150,15 +181,15 @@
 				}
 			}
-			
+
 			$result_u = ldap_get_entries($ldap, $result_r);
-			
+
 			$i = 0;
 			foreach ($result_u as $index => $result_p)
 			{
-				if ($index === 'count' or $index === 'dn' or $result_p['phpgwaccountvisible'][0] == '-1')
+				if ($index === 'count' or $index === 'dn' or (!$this->external and $result_p['phpgwaccountvisible'][0] == '-1'))
 				{
 					continue;
 				}
-				
+
 				foreach ($trans_f as $orig => $trans)
 				{
@@ -178,23 +209,23 @@
 				$i++;
 			}
-			
+
 			return $return;
 		}
-		
+
 		/*
-		
+
 			@function translate_fields
 			@abstract Return the LDAP objectClass fields that corresponds to the
 				specified parameter fields
 			@author Raphael Derosso Pereira
-			
+
 			@param array $fields The fields in the standard ContactCenter format
 			@param array $rules The rules
-		
+
 		*/
 		function translate_fields ( $fields, &$restric_fields )
 		{
 			$return = array();
-			
+
 			$i = 0;
 			foreach ($fields as $field)
@@ -204,12 +235,13 @@
 					continue;
 				}
-				
+
 				if (!is_array($this->trans_table[$field]))
 				{
 					$reference = $this->trans_table[$field];
-					
+
 					reset($restric_fields);
 					while(list(,$field_r) = each($restric_fields))
 					{
+
 						if ($field_r['field'] === $reference and array_key_exists($field_r['value'], $this->trans_table[$reference]))
 						{
@@ -220,4 +252,5 @@
 				else
 				{
+
 					if (!is_array($return[$field]))
 					{
@@ -230,22 +263,22 @@
 				}
 			}
-			
+
 			if (count($return))
 			{
 				return $return;
 			}
-			
+
 			return false;
 		}
-		
+
 		/*
-		
+
 			@function process_restrictions
 			@abstract Returns a LDAP filter string that corresponds to the
 				specified restriction rules
 			@author Raphael Derosso Pereira
-			
+
 			@param string $rules The restriction rules
-		
+
 		*/
 		function process_restrictions( $rules, &$trans_table, $join_type='&' )
@@ -255,5 +288,5 @@
 				return null;
 			}
-			
+
 			foreach($rules as $rule_i => $rule)
 			{
@@ -267,13 +300,13 @@
 								$join = '|';
 								break;
-								
+
 							case 'AND':
 								$join = '&';
 								break;
-								
+
 							case 'NOT':
 								$join = '!';
 								break;
-								
+
 							default:
 								$join = $join_type;
@@ -281,5 +314,5 @@
 						$return_t[] = $this->process_restrictions($rule['sub_branch'], $trans_table, $join);
 						break;
-						
+
 					case '=':
 						if (array_key_exists($rule['field'], $trans_table))
@@ -292,6 +325,6 @@
 						}
 						break;
-					
-					case '!=':	
+
+					case '!=':
 						if (array_key_exists($rule['field'], $trans_table))
 						{
@@ -303,5 +336,5 @@
 						}
 						break;
-					
+
 					case '<=':
 					case '<':
@@ -315,5 +348,5 @@
 						}
 						break;
-					
+
 					case '>':
 					case '>=':
@@ -327,5 +360,5 @@
 						}
 						break;
-						
+
 					case 'NULL':
 						if (array_key_exists($rule['field'], $trans_table))
@@ -338,5 +371,5 @@
 						}
 						break;
-					
+
 					case 'IN':
 						if (array_key_exists($rule['field'], $trans_table))
@@ -358,5 +391,5 @@
 							$value_1 = strtoupper(str_replace('%', '*', $rule['value']));
 							$value_2 = strtolower($value_1);
-							
+
 							foreach($trans_table[$rule['field']] as $field)
 							{
@@ -367,10 +400,10 @@
 						}
 						break;
-						
+
 */					case 'LIKE':
 						if (array_key_exists($rule['field'], $trans_table))
 						{
 							$value = str_replace('%', '*', $rule['value']);
-							
+
 							foreach($trans_table[$rule['field']] as $field)
 							{
@@ -380,5 +413,5 @@
 						}
 						break;
-						
+
 					case 'NOT NULL':
 						if (array_key_exists($rule['field'], $trans_table))
@@ -391,5 +424,5 @@
 						}
 						break;
-					
+
 					case 'NOT IN':
 						if (array_key_exists($rule['field'], $trans_table))
@@ -411,5 +444,5 @@
 							$value_1 = strtoupper(str_replace('%', '*', $rule['value']));
 							$value_2 = strtolower($value_1);
-							
+
 							foreach($trans_table[$rule['field']] as $field)
 							{
@@ -425,5 +458,5 @@
 						{
 							$value = str_replace('%', '*', $rule['value']);
-							
+
 							foreach($trans_table[$rule['field']] as $field)
 							{
@@ -435,5 +468,5 @@
 				}
 			}
-			
+
 			if (count($return_t))
 			{
@@ -453,12 +486,12 @@
 
 		/*!
-		
+
 			@function get_restrictions_without_branch
 			@abstract Returns an array containing the restrictions ignoring the
 				branches
 			@author Raphael Derosso Pereira
-			
+
 			@param array $restrictions The restrictions
-		
+
 		*/
 		function get_restrictions_without_branch(&$restrictions)
@@ -468,7 +501,7 @@
 				return null;
 			}
-			
+
 			$fields = array();
-			
+
 			foreach ($restrictions as $restrict_data)
 			{
@@ -478,7 +511,7 @@
 						$fields = array_merge($fields, $this->get_restrictions_without_branch($restrict_data['sub_branch']));
 						break;
-						
+
 					case '=':
-					case '!=':	
+					case '!=':
 					case '<=':
 					case '<':
@@ -495,35 +528,35 @@
 						array_push($fields, $restrict_data);
 						break;
-						
+
 					default:
-						exit('Error in '.__FILE__.' on '.__LINE__.'<br>The restriction type passed was: '.$restrict_data['type']);					
-				}
-			}
-			
+						exit('Error in '.__FILE__.' on '.__LINE__.'<br>The restriction type passed was: '.$restrict_data['type']);
+				}
+			}
+
 			return $fields;
 		}
-		
-		
+
+
 		/*********************************************************************\
 		 *                        Methods to Get Data                        *
 		\*********************************************************************/
-		
-	
+
+
 		/*!
-		
+
 		 @function get_single_entry
 		 @abstract Returns all information requested about one contact
 		 @author Raphael Derosso Pereira
-		     
+
 		 @param integer $id_contact The contact ID
 		 @param array $fields The array returned by get_fields with true
 		 	on the fields to be taken.
-		 	
+
 		*/
 		function get_single_entry ( $id_contact, $fields )
 		{
-			if (!is_array($fields)) 
-			{
-				if (is_object($GLOBALS['phpgw']->log)) 
+			if (!is_array($fields))
+			{
+				if (is_object($GLOBALS['phpgw']->log))
 				{
 					$GLOBALS['phpgw']->log->message(array(
@@ -531,20 +564,20 @@
 						'line' => __LINE__,
 						'file' => __FILE__));
-					
+
 					$GLOBALS['phpgw']->log->commit();
 				}
-				else 
+				else
 				{
 					exit('Argument Error on: <br>File:'.__FILE__.'<br>Line:'.__LINE__.'<br>');
 				}
 			}
-			
+
 			$ldap = $GLOBALS['phpgw']->common->ldapConnect($this->src_info['host'],$this->src_info['acc'],$this->src_info['pw'],true);
-			
+
 			if (!$ldap)
 			{
 				return false;
 			}
-			
+
 			$resource = ldap_read($ldap, $id_contact, 'objectClass='.$this->src_info['obj']);
 			$n_entries = ldap_count_entries($ldap, $resource);
@@ -553,15 +586,15 @@
 				return false;
 			}
-			
+
 			$first_entry = ldap_first_entry($ldap, $resource);
 			$contact = ldap_get_attributes($ldap,$first_entry);
-			if($contact['jpegPhoto']){	
-				$contact['jpegPhoto'] = ldap_get_values_len ($ldap, $first_entry, "jpegPhoto"); 
+			if($contact['jpegPhoto']){
+				$contact['jpegPhoto'] = ldap_get_values_len ($ldap, $first_entry, "jpegPhoto");
 			}
 
 //			print_r($contact);
-			
+
 		//	$contact_data = $this->fields;
-			
+
 			foreach($fields as $field => $trueness)
 			{
@@ -571,5 +604,5 @@
 					continue;
 				}
-				
+
 				switch ($field)
 				{
@@ -580,5 +613,5 @@
 						$l_fields['department']    = $this->trans_table['contact.business_info.department'];
 						$l_fields['company_notes'] = $this->trans_table['contact.company.company_notes'];
-						
+
 						$contact_data['companies'] = array();
 						foreach($l_fields as $l_field => $l_value)
@@ -588,8 +621,8 @@
 								continue;
 							}
-							
-							$contact_data['companies']['company1'][$l_field] = $contact[$l_value[0]][0];
-						}
-						
+
+							$contact_data['companies']['company1'][$l_field] = utf8_decode($contact[$l_value[0]][0]);
+						}
+
 						if (!(count($contact_data['companies'])))
 						{
@@ -597,5 +630,5 @@
 						}
 						break;
-					
+
 					case 'relations':
 						unset($l_fields);
@@ -604,5 +637,5 @@
 							unset($contact_data['relations']);
 						}
-						
+
 						$contact_data['relations'] = array();
 						if (!is_array($this->trans_table['contact.contact_related.names_ordered']))
@@ -612,5 +645,5 @@
 								continue;
 							}
-							
+
 							$i = 1;
 							foreach($trans as $l_type => $l_type_fields)
@@ -620,11 +653,11 @@
 									continue;
 								}
-								
+
 								$contact_data['relations']['relation'.$i]['type'] = $l_type;
-								$contact_data['relations']['relation'.$i]['names_ordered'] = $contact[$l_type_fields[0]][0];
+								$contact_data['relations']['relation'.$i]['names_ordered'] = utf8_decode($contact[$l_type_fields[0]][0]);
 								$i++;
 							}
 						}
-						
+
 						if (!(count($contact_data['relations'])))
 						{
@@ -632,5 +665,5 @@
 						}
 						break;
-					
+
 					case 'addresses':
 						unset($l_fields);
@@ -661,5 +694,5 @@
 									continue;
 								}
-								
+
 								$i = 1;
 								foreach($trans as $l_type => $l_type_fields)
@@ -669,7 +702,7 @@
 										continue;
 									}
-									
+
 									$contact_data['addresses']['address'.$i]['type'] = $l_type;
-									$contact_data['addresses']['address'.$i][$l_field] = $contact[$l_type_fields[0]][0];
+									$contact_data['addresses']['address'.$i][$l_field] = utf8_decode($contact[$l_type_fields[0]][0]);
 									$i++;
 								}
@@ -677,8 +710,8 @@
 							else
 							{
-								$contact_data['addresses']['address1'][$l_field] = $contact[$l_value[0]][0];
-							}
-						}
-						
+								$contact_data['addresses']['address1'][$l_field] = utf8_decode($contact[$l_value[0]][0]);
+							}
+						}
+
 						if (!(count($contact_data['addresses'])))
 						{
@@ -686,5 +719,5 @@
 						}
 						break;
-					
+
 					case 'connections':
 	                    $preferences = ExecMethod('contactcenter.ui_preferences.get_preferences');
@@ -707,5 +740,5 @@
 									continue;
 								}
-								
+
 								$i = 1;
 								foreach($trans as $l_type => $l_type_fields)
@@ -715,5 +748,5 @@
 										continue;
 									}
-									
+
 									switch ($l_type)
 									{
@@ -726,5 +759,5 @@
 									}
 									$contact_data['connections']['connection'.$i]['type'] = $l_type;
-									$contact_data['connections']['connection'.$i][$l_field] = $contact[$l_type_fields[0]][0];
+									$contact_data['connections']['connection'.$i][$l_field] = utf8_decode($contact[$l_type_fields[0]][0]);
 									$i++;
 								}
@@ -732,8 +765,8 @@
 							else
 							{
-								$contact_data['connections']['connection1'][$l_field] = $contact[$l_value[0]][0];
-							}
-						}
-						
+								$contact_data['connections']['connection1'][$l_field] = utf8_decode($contact[$l_value[0]][0]);
+							}
+						}
+
 						if (!(count($contact_data['connections'])))
 						{
@@ -741,5 +774,5 @@
 						}
 						break;
-					
+
 					case 'prefix':
 						unset($l_fields);
@@ -750,8 +783,8 @@
 							continue;
 						}
-						
-						$contact_data['prefix'] = $contact[$l_fields[0]][0];
-						break;
-						
+
+						$contact_data['prefix'] = utf8_decode($contact[$l_fields[0]][0]);
+						break;
+
 					case 'suffix':
 						unset($l_fields);
@@ -762,8 +795,8 @@
 							continue;
 						}
-						
-						$contact_data['suffix'] = $contact[$l_fields[0]][0];
-						break;
-						
+
+						$contact_data['suffix'] = utf8_decode($contact[$l_fields[0]][0]);
+						break;
+
 					case 'status':
 						unset($l_fields);
@@ -774,8 +807,8 @@
 							continue;
 						}
-						
-						$contact_data['status'] = $contact[$l_fields[0]][0];
-						break;
-						
+
+						$contact_data['status'] = utf8_decode($contact[$l_fields[0]][0]);
+						break;
+
 						case 'photo':
 						unset($l_fields);
@@ -786,7 +819,7 @@
 							continue;
 						}
-						
+
 						$contact_data['photo'] = $contact[$l_fields[0]][0];
-						break;											
+						break;
 
 					default:
@@ -798,27 +831,360 @@
 							continue;
 						}
-						
+
 						if(count($contact[$l_fields[0]]) > 1)
-							$contact_data[$field] = $contact[$l_fields[0]];
+						{
+							$tmp = array();
+							foreach ($contact[$l_fields[0]] as $i => $j)
+							{
+								$tmp["$i"] = utf8_decode($j);
+							}
+							//$contact_data[$field] = $contact[$l_fields[0]];
+							$contact_data[$field] = $tmp;
+						}
 						else
-							$contact_data[$field] = $contact[$l_fields[0]][0];
-
-						break;
-				}
-			}
-			
+							$contact_data[$field] = utf8_decode($contact[$l_fields[0]][0]);
+
+						break;
+				}
+			}
+
 			if (!is_array($contact_data))
 			{
 				return false;
 			}
-			
+
 			return $contact_data;
 		}
-		
+
+		/*!
+
+		 @function get_all_entries
+		 @abstract Returns all information requested about a bunch of contacts, usually a page
+		 @author Raphael Derosso Pereira
+		 @author Mário César Kolling
+
+		 @param string $filter Filter (returned by generate_filter).
+		 @param array $fields The array returned by get_fields with true
+		 	on the fields to be taken.
+
+		*/
+		function get_all_entries($filter, $fields)
+		{
+			if (!is_array($fields))
+			{
+				if (is_object($GLOBALS['phpgw']->log))
+				{
+					$GLOBALS['phpgw']->log->message(array(
+						'text' => 'F-BadcontactcenterParam, wrong get_single_entry parameters type.',
+						'line' => __LINE__,
+						'file' => __FILE__));
+
+					$GLOBALS['phpgw']->log->commit();
+				}
+				else
+				{
+					exit('Argument Error on: <br>File:'.__FILE__.'<br>Line:'.__LINE__.'<br>');
+				}
+			}
+
+			$ldap = $GLOBALS['phpgw']->common->ldapConnect($this->src_info['host'],$this->src_info['acc'],$this->src_info['pw'],true);
+
+			if (!$ldap)
+			{
+				return false;
+			}
+
+			$resource = @ldap_search($ldap, $this->src_info['dn'], $filter);
+			$n_entries = @ldap_count_entries($ldap, $resource);
+
+			ldap_sort($ldap, $resource, 'cn');
+
+			if ( $n_entries < 1)
+			{
+				return false;
+			}
+
+			$contacts = array();
+
+			for ($entry = ldap_first_entry($ldap, $resource);
+				 $entry != false;
+				 $entry = ldap_next_entry($ldap, $entry))
+			{
+				$contact = ldap_get_attributes($ldap,$entry);
+				if($contact['jpegPhoto']){
+					$contact['jpegPhoto'] = ldap_get_values_len ($ldap, $entry, "jpegPhoto");
+				}
+
+				foreach($fields as $field => $trueness)
+				{
+					if (!$trueness)
+					{
+						//unset($contact_data[$field]);
+						continue;
+					}
+
+					switch ($field)
+					{
+						case 'companies':
+							unset($l_fields);
+							$l_fields['company_name']  = $this->trans_table['contact.company.company_name'];
+							$l_fields['title']         = $this->trans_table['contact.business_info.title'];
+							$l_fields['department']    = $this->trans_table['contact.business_info.department'];
+							$l_fields['company_notes'] = $this->trans_table['contact.company.company_notes'];
+
+							///Relaciona o array com o atributo 'employeeNumber' do RHDS
+							$l_fields['empNumber']     = $this->trans_table['contact.business_info.empNumber'];
+
+							$contact_data['companies'] = array();
+							foreach($l_fields as $l_field => $l_value)
+							{
+								if (!( $contact[$l_value[0]][0]))
+								{
+									continue;
+								}
+
+								$contact_data['companies']['company1'][$l_field] = utf8_decode($contact[$l_value[0]][0]);
+							}
+
+							if (!(count($contact_data['companies'])))
+							{
+								unset($contact_data['companies']);
+							}
+							break;
+
+						case 'relations':
+							unset($l_fields);
+							if (!$this->trans_table['contact.contact_related.names_ordered'])
+							{
+								unset($contact_data['relations']);
+							}
+
+							$contact_data['relations'] = array();
+							if (!is_array($this->trans_table['contact.contact_related.names_ordered']))
+							{
+								if (!($trans = $this->trans_table[$this->trans_table['contact.contact_related.names_ordered']]))
+								{
+									continue;
+								}
+
+								$i = 1;
+								foreach($trans as $l_type => $l_type_fields)
+								{
+									if (!($contact[$l_type_fields[0]][0]))
+									{
+										continue;
+									}
+
+									$contact_data['relations']['relation'.$i]['type'] = $l_type;
+									$contact_data['relations']['relation'.$i]['names_ordered'] = utf8_decode($contact[$l_type_fields[0]][0]);
+									$i++;
+								}
+							}
+
+							if (!(count($contact_data['relations'])))
+							{
+								unset($contact_data['relations']);
+							}
+							break;
+
+						case 'addresses':
+							unset($l_fields);
+							$l_fields['address1'] = $this->trans_table['contact.address.address1'];
+					 		$l_fields['address2'] = $this->trans_table['contact.address.address2'];
+					 		$l_fields['complement'] = $this->trans_table['contact.address.complement'];
+					 		$l_fields['address_other'] = $this->trans_table['contact.address.address_other'];
+							$l_fields['postal_code'] = $this->trans_table['contact.address.postal_code'];
+					 		$l_fields['po_box'] = $this->trans_table['contact.address.po_box'];
+					 		$l_fields['id_city'] = $this->trans_table['contact.address.city.id_city'];
+							$l_fields['city_name'] = $this->trans_table['contact.address.city.city_name'];
+							$l_fields['city_timezone'] = $this->trans_table['contact.address.city.city_timezone'];
+							$l_fields['city_geo_location'] = $this->trans_table['contact.address.city.city_geo_location'];
+							$l_fields['id_state'] = $this->trans_table['contact.address.city.state.id_state'];
+							$l_fields['state_name'] = $this->trans_table['contact.address.city.state.state_name'];
+							$l_fields['state_symbol'] = $this->trans_table['contact.address.city.state.state_symbol'];
+							$l_fields['id_country'] = $this->trans_table['contact.address.city.country.id_country'];
+							$l_fields['country_name'] = $this->trans_table['contact.address.city.country.country_name'];
+					 		$l_fields['address_is_default'] = $this->trans_table['contact.address.address_is_default'];
+
+							$contact_data['addresses'] = array();
+							foreach($l_fields as $l_field => $l_value)
+							{
+								if (!is_array($l_value))
+								{
+									if (!($trans = $this->trans_table[$l_value]))
+									{
+										continue;
+									}
+
+									$i = 1;
+									foreach($trans as $l_type => $l_type_fields)
+									{
+										if (!($contact[$l_type_fields[0]][0]))
+										{
+											continue;
+										}
+
+										$contact_data['addresses']['address'.$i]['type'] = $l_type;
+										$contact_data['addresses']['address'.$i][$l_field] = utf8_decode($contact[$l_type_fields[0]][0]);
+										$i++;
+									}
+								}
+								else
+								{
+									$contact_data['addresses']['address1'][$l_field] = utf8_decode($contact[$l_value[0]][0]);
+								}
+							}
+
+							if (!(count($contact_data['addresses'])))
+							{
+								unset($contact_data['addresses']);
+							}
+							break;
+
+						case 'connections':
+		                    $preferences = ExecMethod('contactcenter.ui_preferences.get_preferences');
+		                    if (!is_array($preferences))
+		                    {
+								$preferences['personCardEmail'] = 1;
+								$preferences['personCardPhone'] = 2;
+							}
+							unset($l_fields);
+					 		$l_fields['connection_name'] = $this->trans_table['contact.connection.connection_name'];
+					 		$l_fields['connection_value'] = $this->trans_table['contact.connection.connection_value'];
+
+							$contact_data['connections'] = array();
+							foreach($l_fields as $l_field => $l_value)
+							{
+								if (!is_array($l_value))
+								{
+									if (!($trans = $this->trans_table[$l_value]))
+									{
+										continue;
+									}
+
+									$i = 1;
+									foreach($trans as $l_type => $l_type_fields)
+									{
+										if (!($contact[$l_type_fields[0]][0]))
+										{
+											continue;
+										}
+
+										switch ($l_type)
+										{
+											case 'email':
+											$contact_data['connections']['connection'.$i]['id_type'] = $preferences['personCardEmail'];
+											break;
+
+											default:
+											$contact_data['connections']['connection'.$i]['id_type'] = $preferences['personCardPhone'];
+										}
+										$contact_data['connections']['connection'.$i]['type'] = $l_type;
+										$contact_data['connections']['connection'.$i][$l_field] = utf8_decode($contact[$l_type_fields[0]][0]);
+										$i++;
+									}
+								}
+								else
+								{
+									$contact_data['connections']['connection1'][$l_field] = utf8_decode($contact[$l_value[0]][0]);
+								}
+							}
+
+							if (!(count($contact_data['connections'])))
+							{
+								unset($contact_data['connections']);
+							}
+							break;
+
+						case 'prefix':
+							unset($l_fields);
+							$l_fields = $this->trans_table['contact.prefixes.prefix'];
+							if (!$l_fields or !$contact[$l_fields[0]][0])
+							{
+								unset($contact_data['prefix']);
+								continue;
+							}
+
+							$contact_data['prefix'] = utf8_decode($contact[$l_fields[0]][0]);
+							break;
+
+						case 'suffix':
+							unset($l_fields);
+							$l_fields = $this->trans_table['contact.suffixes.suffix'];
+							if (!$l_fields or !$contact[$l_fields[0]][0])
+							{
+								unset($contact_data['suffix']);
+								continue;
+							}
+
+							$contact_data['suffix'] = utf8_decode($contact[$l_fields[0]][0]);
+							break;
+
+						case 'status':
+							unset($l_fields);
+							$l_fields = $this->trans_table['contact.status.status_name'];
+							if (!$l_fields or !$contact[$l_fields[0]][0])
+							{
+								unset($contact_data['status']);
+								continue;
+							}
+
+							$contact_data['status'] = utf8_decode($contact[$l_fields[0]][0]);
+							break;
+
+							case 'photo':
+							unset($l_fields);
+							$l_fields = $this->trans_table['contact.photo'];
+							if (!$l_fields or !$contact[$l_fields[0]][0])
+							{
+								unset($contact_data['photo']);
+								continue;
+							}
+
+							$contact_data['photo'] = $contact[$l_fields[0]][0];
+							break;
+
+						default:
+							unset($l_fields);
+							$l_fields = $this->trans_table['contact.'.$field];
+							if (!$l_fields or !$contact[$l_fields[0]][0])
+							{
+								unset($contact_data[$field]);
+								continue;
+							}
+
+							if(count($contact[$l_fields[0]]) > 1)
+							{
+								$tmp = array();
+								foreach ($contact[$l_fields[0]] as $i => $j)
+								{
+									$tmp["$i"] = utf8_decode($j);
+								}
+								//$contact_data[$field] = $contact[$l_fields[0]];
+								$contact_data[$field] = $tmp;
+							}
+							else
+								$contact_data[$field] = utf8_decode($contact[$l_fields[0]][0]);
+
+							break;
+
+					}
+				}
+
+				if (is_array($contact_data))
+				{
+					$contacts[ldap_get_dn($ldap, $entry)] = $contact_data;
+				}
+
+			}
+
+			return $contacts;
+		}
+
 		function get_multiple_entries ( $id_contacts, $fields, $other_data = false )
 		{
 			if (!is_array($id_contacts) or !is_array($fields) or ($other_data != false and !is_array($other_data)))
 			{
-				if (is_object($GLOBALS['phpgw']->log)) 
+				if (is_object($GLOBALS['phpgw']->log))
 				{
 					$GLOBALS['phpgw']->log->message(array(
@@ -826,5 +1192,5 @@
 						'line' => __LINE__,
 						'file' => __FILE__));
-					
+
 					$GLOBALS['phpgw']->log->commit();
 				}
@@ -833,18 +1199,56 @@
 				}
 			}
-			
+
 			$contacts = array();
-	
+
 			if ($other_data)
 			{
 				//TODO
 			}
-	
-			foreach ($id_contacts as $id)
-			{
-				$contacts[$id] = $this->get_single_entry($id,$fields);
-			}
-			
-			return $contacts;
+
+			$filter = $this->generate_filter($id_contacts);
+
+			//$teste = $this->get_all_entries($filter, $fields);
+
+			return $this->get_all_entries($filter, $fields);
+		}
+
+		function generate_filter($id_contacts)
+		{
+			if (($size = count($id_contacts)))
+			{
+				$filter = '(&(objectClass='.$this->src_info['obj'] .  ')(|';
+				for ($i = 0; $i < $size; $i++)
+				{
+
+					/*
+					 * Não utiliza mais a função ldap_explode, usa a expressão regular a seguir para pegar o primeiro
+					 * componente da dn
+					 */
+					preg_match('/^(\w*=[^,]*),.*$/', $id_contacts[$i], $cn);
+
+    				/*
+    				 * Adicionados os str_replace para adicionar caracteres de escape em frente aos caracteres '(' e ')',
+    				 * posteriormente poderá ser necessário substituir por uma expressão regular mais genérica.
+    				 */
+					if ($cn[1])
+					{
+						/*
+						 * Esta operação resolve o problema causado pela conversão de caracteres acentuados realizada
+						 * pela função ldap_explode_dn(). Talvez seja necessário utilizar esta tradução em outros lugares,
+						 * neste caso é mais apropriado colocar dentro de uma função.
+						 */
+						//foreach($cn as $key=>$value){
+	          			//	$cn[$key]=preg_replace("/\\\([0-9A-Fa-f]{2})/e", "''.chr(hexdec('\\1')).''", $value);
+	    				//}
+
+						$filter .= '(' . str_replace(')', '\)', str_replace('(','\(',$cn[1])) . ')';
+					}
+				}
+				$filter .= '))';
+			}
+
+			return $filter;
+
 		}
 
@@ -876,60 +1280,60 @@
 			return null;
 		}
-		
+
 		function get_relations ($id_contact,$extra=false)
 		{
 		}
-		
+
 		function get_addresses ( $id_contact,$extra=false )
 		{
 		}
-		
+
 		function get_connections ( $id_contact,$extra=false )
 		{
 		}
-		
+
 		function get_companies ( $id_contact, $extra=false )
 		{
 		}
-		
+
 		function get_all_prefixes (  )
 		{
 		}
-		
+
 		function get_all_suffixes (  )
 		{
 		}
-		
+
 		function get_all_status (  )
 		{
 		}
-		
+
 		function get_all_relations_types (  )
 		{
 		}
-		
+
 		function get_all_addresses_types (  )
 		{
 		}
-		
+
 		function get_all_connections_types (  )
 		{
 		}
-		
+
 		function get_vcard ( $id_contact )
 		{
 		}
-		
-		
-		
-		
+
+
+
+
 		function get_global_tree ( $root )
 		{
 		}
-	
+
 		function get_actual_brach (  )
 		{
 		}
-	
+
 		function set_actual_branch ( $branch )
 		{
